<?php
/**
 * FILE: shrBann.adm.pri.php
 * SYSTEM: ShRBann - Random Banners Manager
 * ------------------------------------
 * AUTHOR: Lucas Vasconcelos (Sh4d0wn) <vasconcelos@mma.com.br>
 * DATE: 20/04/2004
 * FILE VERSION: 1.0
 * NOTE: Script que oferece recurssos basicos para gerenciamento de
 *       um sistema de banners aleatorios.
 * ------------------------------------
 * LAST UPTADE:
 * AUTHOR:
 * NOTE:
 */

include(getenv(DOCUMENT_ROOT)."/x/shio.inc.php");
include(___DOC_ROOT."/x/inc/shrbann.vars.inc.php");
include(___DOC_ROOT."/x/class/dbConnect.class.php");
include(___DOC_ROOT."/x/class/FastTemplate.class.php");

$dc_action         = $_GET['action'];
$no_page           = $_GET['page'];
$tp_send           = $_POST['send'];
$cd_bann_post      = $_POST['cd_bann'];
$dc_url            = $_POST['url'];
$dc_link           = $_POST['link'];
$fl_type           = $_POST['type'];
$no_max_show       = $_POST['max_show'];
$no_import         = $_POST['importa'];
$dt_conquest_day   = $_POST['conquest_day'];
$dt_conquest_month = $_POST['conquest_month'];
$dt_conquest_year  = $_POST['conquest_year'];
$dc_file_name      = $_FILES['file']['name'];
$dc_file_type      = $_FILES['file']['type'];
$dc_file_size      = $_FILES['file']['size'];
$dc_file_temp      = $_FILES['file']['tmp_name'];

empty($_GET['id']) ? $cd_bann = $_POST['cd_bann'] : $cd_bann = base64_decode($_GET['id']);

$ob_temp = new FastTemplate($___COMMON['theme_dir']);
$ob_sql = new dbConnect($___COMMON['db']);

$ob_temp->define(array(
    'sh_page'=>'shrbann.adm.pri.tpl',
    'sh_list'=>'shrbann.adm.list.pri.tpl',
    'sh_css'=>$___COMMON['css'],
    'sh_new_edit'=>'shrbann.adm.newedit.pri.tpl',
    'pagenumbers'=>'shrbann.comm.page_number.tpl'));

$ob_temp->parse('{CSS}', 'sh_css');

if (!empty($dc_action)) {
    switch ($dc_action) {
        case 'new':
/*******************************************************************************
 * EXIBE FORMULARIO PARA CADASTRO DE NOVO BANNER
 ******************************************************************************/

        $ob_temp->parse('{PG:NEW}', 'sh_new_edit');
        $ob_temp->assign('{FR:ACTION}', 'add');
        $ob_temp->assign('{ST:PART}', 'Cadastro de novo banner');
        $ob_temp->assign('{FR:DC_URL}', '');
        $ob_temp->assign('{FR:FL_TYPE}', '');
        $ob_temp->assign('{FR:NO_MAX_SHOW}', '');
        $ob_temp->assign('{FR:DT_CONQUEST}', '');
        $ob_temp->assign('{FR:MAX_FILE_SIZE}', $___SHRBANN['max_file_size']);
        $ob_temp->assign('{FR:NEW_ONLY}', '');
        
        $ob_temp->assign('{FR:CONQUEST_DAY}', '');
        $ob_temp->assign('{FR:CONQUEST_MONTH}', '');
        $ob_temp->assign('{FR:CONQUEST_YEAR}', '');
        $ob_temp->assign('{FR:BANN_URL}', '');
        
        // set default selected dc_import
        for ($x=1; $x<=5; $x++) {
            ($x==2) ? $tp = "selected" : $tp = "";
            $ob_temp->assign("{FR:FL_ENABLE_".$x."}", $tp);
        }
        

/*******************************************************************************
 * FIM / NOVO BANNER
 ******************************************************************************/
            break;
        case 'add':
/*******************************************************************************
 * ENVIA E REGISTRA O NOVO BANNER
 ******************************************************************************/

        $ob_temp->assign('{PG:NEW}', '');
        $tp_err = "";
        
        if (!empty($dt_conquest_day) && !empty($dt_conquest_month) && !empty($dt_conquest_year)) {
            if (!checkdate($dt_conquest_month, $dt_conquest_day, $dt_conquest_year)) {
                $tp_err = "A data digitada  invlida.<br />";
            } else if ( mktime(0,0,0,$dt_conquest_month,$dt_conquest_day,$dt_conquest_year) <= mktime(0,0,0,date('m'),date('d'),date('Y')) ) {
                $tp_err .= "A data digitada deve ser maior que a data atual.<br />";
            }
        }
        
        if ($no_max_show != "" && !is_numeric($no_max_show)) {
            $tp_err .= "O nmero mximo de exibies deve ser um nmero.<br />";
        }
        
        if (empty($no_max_show) && (empty($dt_conquest_day) || empty($dt_conquest_month) || empty($dt_conquest_year))) {
            $tp_err .= "Voc deve definir uma data de validade ou um nmero mximo de exibies para o banner.<br />";
        }
        
        // check if post file or url
        ($dc_file_name!='') ? $tp = $___SHRBANN['url_bann'].$dc_file_name : $tp = $dc_url;
        
        if ($dc_file_type == 'image/pjpeg' || $dc_file_type == 'image/gif' || $fl_type == '1') {
            $dc_tag_bann = "<a href='$dc_link' target='_blank'><img border='0' src='".$tp."'></a>";
        } else {
            $dc_tag_bann = "<EMBED src='".$tp."' quality=high WIDTH=\"468\" HEIGHT=\"60\" ALIGN=\"\" TYPE=\"application/x-shockwave-flash\" PLUGINSPAGE=\"http://www.macromedia.com/go/getflashplayer\"></EMBED>";
        }

        // checa se o banner foi submetido ou foi passada uma url
        if ($dc_file_name != "") {

            if ($dc_file_size > $___SHRBANN['max_file_size']) {
                $tp_err .= "O arquivo submetido deve ter no mximo ".number_format($___SHRBANN['max_file_size']/1024,'2','.','')."Kb.<br />";
            }
            
            if ($dc_file_type != 'image/pjpeg' && $dc_file_type != 'image/gif' && $dc_file_type != 'application/x-shockwave-flash') {
                $tp_err .= "O arquivo submetido deve ter algum dos tipos listados: .jpg .gif ou .swf.<br />";
            }
            
            if (file_exists($___SHRBANN['bann_dir'].$dc_file_name)) {
                $tp_err .= "J existe um arquivo com o nome ".$dc_file_name." no servidor. Renomei-o e tente novamente.<br />";
            }
            
            if ($tp_err != "") {
                $ob_temp->assign('{ST:DC_MSG}', $tp_err);
            } else {
                if (!move_uploaded_file($dc_file_temp, $___SHRBANN['bann_dir'].$dc_file_name)) {
                    $tp_err .= "Ocorreu um erro ao tentar enviar o arquivo para o servidor e a operao foi cancelada.<br /> Por favor tente novamente. Se o problema percistir contacte o WebMaster.";
                }
            }
        }
        
        if ($tp_err != "") {
            $ob_temp->assign('{ST:DC_MSG}', $tp_err);
        } else {
            $ob_temp->assign('{ST:DC_MSG}', '');
            $ob_sql->fn_dbQuery("insert into ".$___SHRBANN['table']." (no_max_show,no_import,nm_file,dc_tag_bann,dt_registry,dt_conquest,dc_url) values (
                '".addslashes($no_max_show)."','".addslashes($no_import)."','".addslashes($dc_file_name)."',
                '".addslashes($dc_tag_bann)."','".date('Y-m-d')."','".addslashes($dt_conquest_year.'-'.$dt_conquest_month.'-'.$dt_conquest_day)."',
                '".addslashes($tp)."')");
        }
        
/*******************************************************************************
 * FIM / ADICIONA BANNER
 ******************************************************************************/
            break;
        case 'edit':
/*******************************************************************************
 * EXIBE FORM PARA EDICAO DO BANNER SELECIONADO / EDIT
 ******************************************************************************/

        $tp_sql = $ob_sql->fn_dbQuery("select cd_bann,nm_file,dc_tag_bann,dc_url,no_show,no_max_show,
            no_temp,no_import,date_format(dt_conquest,'%d/%m/%Y') dt_conquest,
            date_format(dt_registry,'%d/%m/%Y') dt_registry from bann010 where cd_bann='".$cd_bann."'");
            
        if ($ob_sql->fn_getRows($tp_sql)!=0) {
            $ob_temp->assign('{FR:DISABLE_D}', 'disabled');
            
            $ar_sql = $ob_sql->fn_getArray($tp_sql);
            
            $ob_temp->parse('{PG:NEW}', 'sh_new_edit');
            $ob_temp->assign('{FR:ACTION}', 'update');
            $ob_temp->assign('{ST:PART}', 'Editar banner');
            $ob_temp->assign('{FR:BANN_URL}', $ar_sql[0]['dc_url']);
            $ob_temp->assign('{FR:FL_TYPE}', '');
            $ob_temp->assign('{FR:NO_MAX_SHOW}', $ar_sql[0]['no_max_show']);
            
            $ar_conquest = explode('/', $ar_sql[0]['dt_conquest']);
            
            $ob_temp->assign('{FR:CONQUEST_DAY}', $ar_conquest[0]);
            $ob_temp->assign('{FR:CONQUEST_MONTH}', $ar_conquest[1]);
            $ob_temp->assign('{FR:CONQUEST_YEAR}', $ar_conquest[2]);
            
            $ob_temp->assign('{FR:CD_BANN}', $ar_sql[0]['cd_bann']);
            $ob_temp->assign('{FR:NEW_ONLY}', 'disabled');
            $ob_temp->assign('{FR:MAX_FILE_SIZE}', $___SHRBANN['max_file_size']);
            // set default selected dc_import
            for ($x=1; $x<=5; $x++) {
                ($ar_sql[0]['no_import']==($x*2)) ? $tp = 'selected' : $tp = '';
                $ob_temp->assign("{FR:FL_ENABLE_".$x."}", $tp);
            }
        } else {
            $ob_temp->assign('{ST:DC_MSG}', 'O Cdigo informado  invlido.');
        }

/*******************************************************************************
 * FIM / EDIT FORM
 ******************************************************************************/
            break;
        case 'update':
/*******************************************************************************
 * ATUALIZA DADOS DO BANNER
 ******************************************************************************/
        $ob_temp->assign('{PG:NEW}', '');
        $tp_err = "";
        
        if (!empty($dt_conquest_day) && !empty($dt_conquest_month) && !empty($dt_conquest_year)) {
            if (!checkdate($dt_conquest_month, $dt_conquest_day, $dt_conquest_year)) {
                $tp_err = "A data digitada  invlida.<br />";
            }
        }
        
        if (!is_numeric($no_max_show)) {
            $tp_err .= "O nmero mximo de exibies deve ser inteiro.<br />";
        }
        
        if (empty($no_max_show) && (empty($dt_conquest_day) || empty($dt_conquest_month) || empty($dt_conquest_year))) {
            $tp_err .= "Voc deve definir uma data de validade ou um nmero mximo de exibies para o banner.<br />";
        }
        
        if ($tp_err != "") {
            $ob_temp->assign('{ST:DC_MSG}', $tp_err);
        } else {
            $ob_sql->fn_dbQuery("update bann010 set dt_conquest='".addslashes($dt_conquest_year.'-'.$dt_conquest_month.'-'.$dt_conquest_day)."', no_max_show='".addslashes($no_max_show)."' where cd_bann='".$cd_bann_post."'");
        }

/*******************************************************************************
 * FIM / ATUALIZA DADOS
 ******************************************************************************/
            break;
        case 'del':
/*******************************************************************************
 * EXCLUI BANNER SELECIONADO
 ******************************************************************************/
 
        $ob_temp->assign('{PG:NEW}', '');
        $tp_err = "";
        $tp_sql = $ob_sql->fn_dbQuery("select nm_file from bann010 where cd_bann='".$cd_bann."' and nm_file!=''");
        if ($ob_sql->fn_getRows($tp_sql)!=0) {
            if (!@unlink($___SHRBANN['bann_dir'].$ob_sql->fn_getResult($tp_sql,"nm_file"))) {
                $ob_temp->assign('{ST:DC_MSG}', 'Falha ao tentar excluir o arquivo '.$ob_sql->fn_getResult($tp_sql,"nm_file").'.');
                $tp_err = '1';
            }
        }
        
        if ($tp_err != '1') {
            $ob_sql->fn_dbQuery("delete from bann010 where cd_bann='" .$cd_bann. "'");
            $ob_temp->assign('{ST:DC_MSG}','');
        }
        
/*******************************************************************************
 * EXCLUI BANNER SELECIONADO
 ******************************************************************************/
            break;
        default:
            // show error mesage
            $ob_temp->assign('{PG:NEW}', '');
            break;
    }
} else {
    $ob_temp->assign('{PG:NEW}', '');
    $ob_temp->assign('{ST:DC_MSG}', '');
}

$ob_temp->assign('{ST:LOGO}', $__COMMON['site_logo']);

/*******************************************************************************
 * STRINGS ALTERAVEIS
 ******************************************************************************/
$ob_temp->assign('{ST:TITLE}', 'Sh4d0wn\'s page : ShRBann - Admin');
$ob_temp->assign('{ST:PAGE_TITLE}', 'Sh4d0wn\'s Random Banners');
$ob_temp->assign('{ST:URL}', $__COMMON['site_url']);
$ob_temp->assign('{ST:DEFAULT_LOGOUT}', '');

// ---------------------
// LISTA DEFAULT



$tp_sql = $ob_sql->fn_dbQuery("select cd_bann,nm_file,dc_tag_bann,no_show,no_max_show,
    no_temp,dc_url,no_import,date_format(dt_conquest,'%d/%m/%Y') dt_conquest,
    date_format(dt_registry,'%d/%m/%Y') dt_registry from bann010 order by cd_bann desc");

if ($ob_sql->fn_getRows($tp_sql) == 0) {
    $ob_temp->assign('{TR_BANN_LIST}', '<tr><td>At o momento no h bannbers cadastrados.</td></tr>');
    $ob_temp->assign('{TP:PREV}','');
    $ob_temp->assign('{TP:PAGES}','');
    $ob_temp->assign('{TP:NEXT}','');
} else {
    
    $no_results = $ob_sql->fn_getRows($tp_sql);
    $no_max_result = 10;
    $no_pages = ceil($no_results/$___SHRBANN['max_result']);
    $tp_begin = (int)($no_page * $___SHRBANN['max_result']);

    $tp_sql1 = $ob_sql->fn_dbQuery("select cd_bann,nm_file,dc_tag_bann,no_show,no_max_show,
        no_temp,dc_url,no_import,date_format(dt_conquest,'%d/%m/%Y') dt_conquest,
        date_format(dt_registry,'%d/%m/%Y') dt_registry from bann010 order by cd_bann desc limit $tp_begin, ".$___SHRBANN['max_result']."");
        
    $ar_bann_list = $ob_sql->fn_getArray($tp_sql1);
    //var_dump($ar_bann_list);
    
    for ($x=0; $x<count($ar_bann_list); $x++) {
        $ob_temp->parse('{TR_BANN_LIST}', '.sh_list');
        
        $ob_temp->assign('{DB:CD_BANN}', base64_encode($ar_bann_list[$x]['cd_bann']));
        $ob_temp->assign('{DB:NM_BANN}', $ar_bann_list[$x]['nm_bann']);
        $ob_temp->assign('{DB:DC_URL}', '...'.substr($ar_bann_list[$x]['dc_url'],-25));
        $ob_temp->assign('{DB:DC_URL_BANN}', $ar_bann_list[$x]['dc_url']);
        $ob_temp->assign('{DB:DC_TAG_BANN}', '...'.substr($ar_bann_list[$x]['dc_tag_bann'],-25));
        $ob_temp->assign('{DB:NO_SHOW}', $ar_bann_list[$x]['no_show']);
        $ob_temp->assign('{DB:NO_MAX_SHOW}', $ar_bann_list[$x]['no_max_show']);
        $ob_temp->assign('{DB:NO_TEMP}', $ar_bann_list[$x]['no_temp']);
        $ob_temp->assign('{DB:NO_IMPORT}', $ar_bann_list[$x]['no_import']);
        $ob_temp->assign('{DB:DT_CONQUEST}', $ar_bann_list[$x]['dt_conquest']);
        $ob_temp->assign('{DB:DT_REGISTRY}', $ar_bann_list[$x]['dt_registry']);
    }
    
    // -------------------------------------------------------------------------
    // PAGINACAO
    // -------------------------------------------------------------------------

    if ($no_page == "" || $no_page == "0") {
        $ob_temp->assign('{TP:PREV}', '');
    } else {
        $ob_temp->assign('{TP:PREV}', 'Anterior');
        $ob_temp->assign('{TP:PAGE_PREV}', $no_page-1);
    }
    
    if ($no_pages < 2) {
        $ob_temp->assign('{TP:PAGES}', '');
    } else {
        for ($i = $no_pages-1; $i>=0; $i--) {
            $ob_temp->parse('{TP:PAGES}', '.pagenumbers');
            $ob_temp->assign('{TP:NUMBER}', $i);
        }
    }

    if (($no_pages-1) == $no_page) {
        $ob_temp->assign('{TP:NEXT}', '');
    } else {
        $ob_temp->assign('{TP:NEXT}', 'Prxima');
        $ob_temp->assign('{TP:PAGE_NEXT}', $no_page+1);
    }
    
}

// end page

$ob_sql->fn_dbClose();
$ob_temp->parse('OUTPUT', 'sh_page');
$ob_temp->FastPrint('OUTPUT');
?>
